#ifndef AiboBiff_h_DEFINED
#define AiboBiff_h_DEFINED

#include <OPENR/OObject.h>
#include <OPENR/OSubject.h>
#include <OPENR/OObserver.h>
#include <OPENR/ODataArchive.h>
#include <OPENR/OTime.h>
#include <MoNetData.h>
#include "def.h"

#include <list>
using namespace std;

enum AiboBiffState {
    BIFF_IDLE,
    BIFF_READY
};

enum MoNetTestState {
    MNTS_IDLE,
    MNTS_START,
    MNTS_WAITING_RESULT,
    MNTS_SHUTDOWN
};

const MoNetCommandID SLEEP2SLEEP_NULL = 0; // see /OPEN-R/MW/CONF/MONETCMD.CFG

class AiboBiff: public OObject {
public:
    AiboBiff();
    virtual ~AiboBiff() {}

    OSubject*   subject[numOfSubject];
    OObserver*  observer[numOfObserver];     

    virtual OStatus DoInit   (const OSystemEvent& event);
    virtual OStatus DoStart  (const OSystemEvent& event);
    virtual OStatus DoStop   (const OSystemEvent& event);
    virtual OStatus DoDestroy(const OSystemEvent& event);

public:
    void ReadyCommand(const OReadyEvent& event);
    void NotifyResult(const ONotifyEvent& event);

    void NotifySensor(const ONotifyEvent& event);

    void ReadyMailCheck(const OReadyEvent& event);
    void NotifyNewMail(const ONotifyEvent& event);

private:
    void ParseCommandLine(char* cmdline);
    void Execute(MoNetCommandID cmdID);

    MoNetTestState moNetTestState;
    list<MoNetCommandID> commandQueue;
    
    AiboBiffState biffState;
};

#endif // AiboBiff_h_DEFINED
